Index: UPDATING
===================================================================
--- UPDATING	(版本 300087)
+++ UPDATING	(版本 301052)
@@ -16,6 +16,15 @@
 stable/10, and then rebuild without this option. The bootstrap process from
 older version of current is a bit fragile.
 
+20160531	p4	FreeBSD-SA-16:20.linux
+			FreeBSD-SA-16:21.43bsd
+			FreeBSD-SA-16:22.libarchive
+
+	Fix kernel stack disclosure in Linux compatibility layer. [SA-16:20]
+	Fix kernel stack disclosure in 4.3BSD compatibility layer. [SA-16:21]
+	Fix directory traversal in cpio(1). [SA-16:22]
+
+
 20160517	p3	FreeBSD-SA-16:18.atkbd
 			FreeBSD-SA-16:19.sendmsg
 
Index: sys/compat/linux/linux_ioctl.c
===================================================================
--- sys/compat/linux/linux_ioctl.c	(版本 300087)
+++ sys/compat/linux/linux_ioctl.c	(版本 301052)
@@ -915,6 +915,8 @@
 
 	case LINUX_TIOCGSERIAL: {
 		struct linux_serial_struct lss;
+
+		bzero(&lss, sizeof(lss));
 		lss.type = LINUX_PORT_16550A;
 		lss.flags = 0;
 		lss.close_delay = 0;
Index: sys/compat/linux/linux_misc.c
===================================================================
--- sys/compat/linux/linux_misc.c	(版本 300087)
+++ sys/compat/linux/linux_misc.c	(版本 301052)
@@ -150,6 +150,7 @@
 	int i, j;
 	struct timespec ts;
 
+	bzero(&sysinfo, sizeof(sysinfo));
 	getnanouptime(&ts);
 	if (ts.tv_nsec != 0)
 		ts.tv_sec++;
Index: sys/conf/newvers.sh
===================================================================
--- sys/conf/newvers.sh	(版本 300087)
+++ sys/conf/newvers.sh	(版本 301052)
@@ -32,7 +32,7 @@
 
 TYPE="FreeBSD"
 REVISION="10.3"
-BRANCH="RELEASE-p3"
+BRANCH="RELEASE-p4"
 if [ "X${BRANCH_OVERRIDE}" != "X" ]; then
 	BRANCH=${BRANCH_OVERRIDE}
 fi
Index: sys/kern/vfs_syscalls.c
===================================================================
--- sys/kern/vfs_syscalls.c	(版本 300087)
+++ sys/kern/vfs_syscalls.c	(版本 301052)
@@ -2197,6 +2197,7 @@
 	struct ostat *ost;
 {
 
+	bzero(ost, sizeof(*ost));
 	ost->st_dev = st->st_dev;
 	ost->st_ino = st->st_ino;
 	ost->st_mode = st->st_mode;
Index: contrib/libarchive/cpio/bsdcpio.1
===================================================================
--- contrib/libarchive/cpio/bsdcpio.1	(版本 300087)
+++ contrib/libarchive/cpio/bsdcpio.1	(版本 301052)
@@ -156,7 +156,8 @@
 .It Fl Fl insecure
 (i and p mode only)
 Disable security checks during extraction or copying.
-This allows extraction via symbolic links and path names containing
+This allows extraction via symbolic links, absolute paths,
+and path names containing
 .Sq ..
 in the name.
 .It Fl J , Fl Fl xz
Index: contrib/libarchive/cpio/cpio.c
===================================================================
--- contrib/libarchive/cpio/cpio.c	(版本 300087)
+++ contrib/libarchive/cpio/cpio.c	(版本 301052)
@@ -179,6 +179,7 @@
 	cpio->extract_flags |= ARCHIVE_EXTRACT_NO_OVERWRITE_NEWER;
 	cpio->extract_flags |= ARCHIVE_EXTRACT_SECURE_SYMLINKS;
 	cpio->extract_flags |= ARCHIVE_EXTRACT_SECURE_NODOTDOT;
+	cpio->extract_flags |= ARCHIVE_EXTRACT_SECURE_NOABSOLUTEPATHS;
 	cpio->extract_flags |= ARCHIVE_EXTRACT_PERM;
 	cpio->extract_flags |= ARCHIVE_EXTRACT_FFLAGS;
 	cpio->extract_flags |= ARCHIVE_EXTRACT_ACL;
@@ -264,6 +265,7 @@
 		case OPTION_INSECURE:
 			cpio->extract_flags &= ~ARCHIVE_EXTRACT_SECURE_SYMLINKS;
 			cpio->extract_flags &= ~ARCHIVE_EXTRACT_SECURE_NODOTDOT;
+			cpio->extract_flags &= ~ARCHIVE_EXTRACT_SECURE_NOABSOLUTEPATHS;
 			break;
 		case 'L': /* GNU cpio */
 			cpio->option_follow_links = 1;
@@ -300,6 +302,7 @@
 				    "Cannot use both -p and -%c", cpio->mode);
 			cpio->mode = opt;
 			cpio->extract_flags &= ~ARCHIVE_EXTRACT_SECURE_NODOTDOT;
+			cpio->extract_flags &= ~ARCHIVE_EXTRACT_SECURE_NOABSOLUTEPATHS;
 			break;
 		case OPTION_PRESERVE_OWNER:
 			cpio->extract_flags |= ARCHIVE_EXTRACT_OWNER;
Index: contrib/libarchive/libarchive/archive.h
===================================================================
--- contrib/libarchive/libarchive/archive.h	(版本 300087)
+++ contrib/libarchive/libarchive/archive.h	(版本 301052)
@@ -562,6 +562,8 @@
 /* Default: Do not use HFS+ compression if it was not compressed. */
 /* This has no effect except on Mac OS v10.6 or later. */
 #define	ARCHIVE_EXTRACT_HFS_COMPRESSION_FORCED	(0x8000)
+/* Default: Do not reject entries with absolute paths */
+#define ARCHIVE_EXTRACT_SECURE_NOABSOLUTEPATHS (0x10000)
 
 __LA_DECL int archive_read_extract(struct archive *, struct archive_entry *,
 		     int flags);
Index: contrib/libarchive/libarchive/archive_write_disk.3
===================================================================
--- contrib/libarchive/libarchive/archive_write_disk.3	(版本 300087)
+++ contrib/libarchive/libarchive/archive_write_disk.3	(版本 301052)
@@ -177,6 +177,9 @@
 Note that paths ending in
 .Pa ..
 always cause an error, regardless of this flag.
+.It Cm ARCHIVE_EXTRACT_SECURE_NOABSOLUTEPATHS
+Refuse to extract an absolute path.
+The default is to not refuse such paths.
 .It Cm ARCHIVE_EXTRACT_SPARSE
 Scan data for blocks of NUL bytes and try to recreate them with holes.
 This results in sparse files, independent of whether the archive format
Index: contrib/libarchive/libarchive/archive_write_disk_posix.c
===================================================================
--- contrib/libarchive/libarchive/archive_write_disk_posix.c	(版本 300087)
+++ contrib/libarchive/libarchive/archive_write_disk_posix.c	(版本 301052)
@@ -2504,8 +2504,9 @@
 /*
  * Canonicalize the pathname.  In particular, this strips duplicate
  * '/' characters, '.' elements, and trailing '/'.  It also raises an
- * error for an empty path, a trailing '..' or (if _SECURE_NODOTDOT is
- * set) any '..' in the path.
+ * error for an empty path, a trailing '..', (if _SECURE_NODOTDOT is
+ * set) any '..' in the path or (if ARCHIVE_EXTRACT_SECURE_NOABSOLUTEPATHS
+ * is set) if the path is absolute.
  */
 static int
 cleanup_pathname(struct archive_write_disk *a)
@@ -2524,8 +2525,15 @@
 	cleanup_pathname_win(a);
 #endif
 	/* Skip leading '/'. */
-	if (*src == '/')
+	if (*src == '/') {
+		if (a->flags & ARCHIVE_EXTRACT_SECURE_NOABSOLUTEPATHS) {
+			archive_set_error(&a->archive, ARCHIVE_ERRNO_MISC,
+			                  "Path is absolute");
+			return (ARCHIVE_FAILED);
+		}
+
 		separator = *src++;
+	}
 
 	/* Scan the pathname one element at a time. */
 	for (;;) {
Index: contrib/libarchive/libarchive/test/test_write_disk_secure.c
===================================================================
--- contrib/libarchive/libarchive/test/test_write_disk_secure.c	(版本 300087)
+++ contrib/libarchive/libarchive/test/test_write_disk_secure.c	(版本 301052)
@@ -178,6 +178,29 @@
 	assert(S_ISDIR(st.st_mode));
 	archive_entry_free(ae);
 
+	/*
+	 * Without security checks, we should be able to
+	 * extract an absolute path.
+	 */
+	assert((ae = archive_entry_new()) != NULL);
+	archive_entry_copy_pathname(ae, "/tmp/libarchive_test-test_write_disk_secure-absolute_path.tmp");
+	archive_entry_set_mode(ae, S_IFREG | 0777);
+	assert(0 == archive_write_header(a, ae));
+	assert(0 == archive_write_finish_entry(a));
+	assertFileExists("/tmp/libarchive_test-test_write_disk_secure-absolute_path.tmp");
+	assert(0 == unlink("/tmp/libarchive_test-test_write_disk_secure-absolute_path.tmp"));
+
+	/* But with security checks enabled, this should fail. */
+	assert(archive_entry_clear(ae) != NULL);
+	archive_entry_copy_pathname(ae, "/tmp/libarchive_test-test_write_disk_secure-absolute_path.tmp");
+	archive_entry_set_mode(ae, S_IFREG | 0777);
+	archive_write_disk_set_options(a, ARCHIVE_EXTRACT_SECURE_NOABSOLUTEPATHS);
+	failure("Extracting an absolute path should fail here.");
+	assertEqualInt(ARCHIVE_FAILED, archive_write_header(a, ae));
+	archive_entry_free(ae);
+	assert(0 == archive_write_finish_entry(a));
+	assertFileNotExists("/tmp/libarchive_test-test_write_disk_secure-absolute_path.tmp");
+
 	assertEqualInt(ARCHIVE_OK, archive_write_free(a));
 
 	/* Test the entries on disk. */
Index: .
===================================================================
--- .	(版本 300087)
+++ .	(版本 301052)

 属性改变: .
___________________________________________________________________
Modified: svn:mergeinfo
## -0,0 +0,1 ##
   已经合并 /stable/10:r300361
